/*
 * Library interface to Linux x86 Performance-Monitoring Counters.
 *
 * Copyright (C) 1999  Mikael Pettersson
 */
#ifndef __LIB_PERFCTR_H
#define __LIB_PERFCTR_H

#include "asm/perfctr.h"

extern int perfctr_info(struct perfctr_info*);

extern void perfctr_detach_self(void);
extern int perfctr_attach_rdonly_self(void);
extern int perfctr_attach_rdwr_self(void);
extern int perfctr_read_self(struct perfctr_state*);
extern int perfctr_control_self(struct perfctr_control*);
extern int perfctr_stop_self(void);
extern int perfctr_unlink_self(void);

extern int perfctr_attach_rdonly(int pid);
extern int perfctr_attach_rdwr(int pid, struct perfctr_control*);
extern int perfctr_read_attached(int fd, struct perfctr_state*);
extern int perfctr_control_attached(int fd, struct perfctr_control*);
extern int perfctr_stop_attached(int fd);
extern int perfctr_unlink_attached(int fd);

extern const char *perfctr_events_name(void);
extern unsigned int perfctr_evntsel_num_insns(void);

#endif /* __LIB_PERFCTR_H */
